#include <bits/stdc++.h>
#define MOD 1000000007
using namespace std;



int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n,k;
    vector<int> a;
    vector<long long> pom;
    vector<long long> g;
    cin>>n>>k;
    k++;
    for(int i=0;i<n;i++){
        int x;
        cin>>x;
        a.push_back(x);
    }
    g.push_back(1);
    for(int i=0;i<k;i++)pom.push_back(1);

    for(int i=0;i<n-1;i++){
        for(int j=1;j<k;j++){
            pom[j]+=pom[j-1];
            pom[j]%=MOD;
        }
        g.push_back(pom[k-1]);
   }
   long long sum=0;
   for(int i=0;i<n;i++){
        long long x=(g[i]*g[n-i-1])%MOD;
        sum+=(x*a[i])%MOD;
        sum%=MOD;
   }
   cout<<sum<<endl;

return 0;
}